
void check_scheduled_events(void)
{
  long current_millis_plus_1 = millis() + 1;

  for (byte light_number = 0; light_number < NUM_LEDS; light_number++)
  {
    for (byte buffer_index = 0; buffer_index < max_buffered_notes; buffer_index++)
    {
      if (scheduled_noteon_start_millis[light_number][buffer_index] && (current_millis_plus_1 > scheduled_noteon_start_millis[light_number][buffer_index]))
      {
        noteon[light_number] = 1;
        start_millis[light_number] = scheduled_noteon_start_millis[light_number][buffer_index];
        start_brightness_index[light_number] = scheduled_start_brightness_index[light_number][buffer_index];
        current_brightness_index[light_number] = start_brightness_index[light_number];
        scheduled_noteon_start_millis[light_number][buffer_index] = 0;
      }

      if (scheduled_noteoff_start_millis[light_number][buffer_index] && (current_millis_plus_1 > scheduled_noteoff_start_millis[light_number][buffer_index]))
      {
        if (fadeoff_noteoff)
        {
          noteon[light_number] = 0;
          start_brightness_index[light_number] = current_brightness_index[light_number];
          start_millis[light_number] = scheduled_noteoff_start_millis[light_number][buffer_index];
        }

        else // turn off
        {
          noteon[light_number] = 0;
          current_brightness_index[light_number] = 0;
          start_brightness_index[light_number] = 0;
        }

        scheduled_noteoff_start_millis[light_number][buffer_index] = 0;
      }
    }
  }
}


